﻿/*  Copyright (C) MOXA Inc. All rights reserved.

    This software is distributed under the terms of the
    MOXA License.  See the file COPYING-MOXA for details.
*/

using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using moxa;

namespace UartMode
{
    class Program
    {
        static void Main(string[] args)
        {
            uint nPort, nMode;
            nPort = 1;
            nMode =1;
            string smode;
            bool bSetUARTMode = false;

            System.Console.WriteLine("UART Mode Test Program");
            System.Console.WriteLine("\t (0) Exit Program");
            System.Console.WriteLine("\t (1) Display UART Mode");
            System.Console.WriteLine("\t (2) Set  UART Mode");

            //read a char.
            string sin = System.Console.ReadLine();
            int n = int.Parse(sin);

            do
            {
                switch (n)
                {
                    // if char == '1', display current mode
                    case 1:
                        
                        System.Console.Write("Input the Port Number (3~4) = ");
                        smode = System.Console.ReadLine();
                        nPort = uint.Parse(smode);
                        moxa.v460.SerialInterface.SerialMode mode = moxa.v460.SerialInterface.GetComPortInterface(nPort);
                        System.Console.WriteLine("COM{0}={1}", nPort, mode);
                       
                        break;
                    // if char == '2', set uart mode
                    case 2:
                        System.Console.Write("Input the Port Number (3~4) = ");
                        smode = System.Console.ReadLine();
                        nPort = uint.Parse(smode);

                        // read port value from console
                        System.Console.Write("Input the Mode value (0 ~ 3) = ");
                        smode = System.Console.ReadLine();
                        nMode = uint.Parse(smode);

                        //Set uart mode
                        bSetUARTMode=moxa.v460.SerialInterface.SetComPortInterface(nPort, (moxa.v460.SerialInterface.SerialMode)nMode);
                        if (bSetUARTMode == false)
                        {
                            Console.WriteLine("SetComPortInterface Fail.\n");
                            break;
                        }
                        mode = moxa.v460.SerialInterface.GetComPortInterface(nPort);
                        System.Console.WriteLine("COM{0}={1}", nPort, mode);
                        break;
                                               
                  }
                  sin = System.Console.ReadLine();
                  n = int.Parse(sin);
              } while (n != 0);
         }
    }
}
