﻿/*  Copyright (C) MOXA Inc. All rights reserved.

    This software is distributed under the terms of the
    MOXA License.  See the file COPYING-MOXA for details.
*/

using System;
using System.Collections.Generic;
using System.Text;
using moxa;

namespace UartMode
{
    class UartMode
    {
        static void Main(string[] args)
        {
            int nPort, nMode;
            nPort = 0;
            nMode = 0;

            nPort = Convert.ToInt32(args[0]);
            nMode = Convert.ToInt32(args[1]);

            //Set uart mode
            moxa.v460.SerialInterface.setUartMode(nPort, (moxa.v460.SerialInterface.SerialMode)nMode);

            //Get uart modenPort
            moxa.v460.SerialInterface.SerialMode mode = moxa.v460.SerialInterface.getUartMode(nPort);

            System.Console.WriteLine("COM{0}={1}", nPort, mode);
        }
    }
}
